package tasks

import (
	"ocl/portainer-devtool/configs"
	"ocl/portainer-devtool/tasks/common"
	"ocl/portainer-devtool/tasks/subtasks"
)

type ListDevToolCommandTask struct {
	common.GeneralTask
}

func NewListDevToolCommandTask(cfg *configs.Config) *ListDevToolCommandTask {
	return &ListDevToolCommandTask{
		GeneralTask: *common.NewGeneralTask(cfg),
	}
}

func (task *ListDevToolCommandTask) Execute() error {
	subTaskItems := []common.Tasker{
		subtasks.NewListVolumeSubTask(task.Config),
		subtasks.NewListRepositorySubTask(task.Config),
	}

	for _, taskItem := range subTaskItems {
		taskItem.SetParentTaskers(subTaskItems)
	}

	// ListCommandMenu(subTaskItems, "Which management commands do you want to choose:")
	common.ListCommandMenu(subTaskItems, "Which management commands do you want to choose:", false, task.ParentTasks)

	return nil
}

func (task *ListDevToolCommandTask) String() string {
	return "List Dev Tool Commands"
}
